/*
 * BluSunrize
 * Copyright (c) 2017
 *
 * This code is licensed under "Blu's License of Common Sense"
 * Details can be found in the license file in the root folder of this project
 */

package blusunrize.immersiveengineering.client.render;

import blusunrize.immersiveengineering.api.IEProperties;
import blusunrize.immersiveengineering.client.ClientUtils;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.blocks.metal.TileEntityMixer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.block.model.IBakedModel;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.fluids.FluidStack;
import org.lwjgl.opengl.GL11;

public class TileRenderMixer extends TileEntitySpecialRenderer<TileEntityMixer>
{
	@Override
	public void func_192841_a(TileEntityMixer te, double x, double y, double z, float partialTicks, int destroyStage, float alpha)
	{
		if(!te.formed || te.isDummy() || !te.func_145831_w().func_175668_a(te.func_174877_v(), false))
			return;

		final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
		BlockPos blockPos = te.func_174877_v();
		IBlockState state = func_178459_a().func_180495_p(blockPos);
		if(state.func_177230_c() != IEContent.blockMetalMultiblock)
			return;
		state = state.func_177230_c().func_176221_a(state, func_178459_a(), blockPos);
		state = state.func_177226_a(IEProperties.DYNAMICRENDER, true);
		IBakedModel model = blockRenderer.func_175023_a().func_178125_b(state);

		Tessellator tessellator = Tessellator.func_178181_a();
		BufferBuilder worldRenderer = tessellator.func_178180_c();

		ClientUtils.bindAtlas();
		GlStateManager.func_179094_E();
		GlStateManager.func_179137_b(x+.5, y+.5, z+.5);

		if(te.mirrored)
			GlStateManager.func_179152_a(te.facing.func_82601_c()==0?-1:1,1,te.facing.func_82599_e()==0?-1:1);

		GlStateManager.func_179094_E();
		GlStateManager.func_179137_b(te.facing==EnumFacing.SOUTH||te.facing==EnumFacing.WEST?-.5:.5, 0, te.facing==EnumFacing.SOUTH||te.facing==EnumFacing.EAST?.5:-.5);
		float agitator = te.animation_agitator-(!te.shouldRenderAsActive()?0:(1-partialTicks)*9f);
		GlStateManager.func_179114_b(agitator, 0,1,0);

		RenderHelper.func_74518_a();
		GlStateManager.func_179112_b(770, 771);
		GlStateManager.func_179147_l();
		GlStateManager.func_179129_p();
		if(Minecraft.func_71379_u())
			GlStateManager.func_179103_j(7425);
		else
			GlStateManager.func_179103_j(7424);
		worldRenderer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
		worldRenderer.func_178969_c( -.5-blockPos.func_177958_n(), -.5- blockPos.func_177956_o(),  -.5-blockPos.func_177952_p());
		worldRenderer.func_181669_b(255, 255, 255, 255);
		blockRenderer.func_175019_b().func_178267_a(te.func_145831_w(), model, state, blockPos, worldRenderer, true);
		worldRenderer.func_178969_c(0.0D, 0.0D, 0.0D);
		tessellator.func_78381_a();
		RenderHelper.func_74519_b();

		GlStateManager.func_179121_F();

		switch(te.facing)
		{
			case NORTH:
				break;
			case SOUTH:
				GlStateManager.func_179114_b(180, 0, 1, 0);
				break;
			case WEST:
				GlStateManager.func_179114_b(90, 0, 1, 0);
				break;
			case EAST:
				GlStateManager.func_179114_b(-90, 0, 1, 0);
				break;
		}

		GlStateManager.func_179152_a(.0625f,1,.0625f);
		GlStateManager.func_179114_b(90, 1,0,0);
		GlStateManager.func_179109_b(8,-8,.625f);

		RenderHelper.func_74518_a();

		for(int i=te.tank.getFluidTypes()-1; i>=0; i--)
		{
			FluidStack fs = te.tank.fluids.get(i);
			if(fs!=null&&fs.getFluid()!=null)
			{
				int col = fs.getFluid().getColor(fs);
				GlStateManager.func_179131_c((col>>16&255)/255.0f,(col>>8&255)/255.0f,(col&255)/255.0f, 1);

				float yy = fs.amount/(float)te.tank.getCapacity()*1.125f;
				GlStateManager.func_179109_b(0, 0, -yy);
				float w = (i<te.tank.getFluidTypes()-1||yy>=.125)?26: 16+yy/.0125f;
				ClientUtils.drawRepeatedFluidSprite(fs, -w/2, -w/2, w, w);
			}
		}

		GlStateManager.func_179121_F();
	}
}
